#!/usr/bin/perl

#
# search.pl - The Perlfect Search Engine
# version 1.1
#
# (c) 1998 Giorgos Zervas, Perlfect Solutions
# giorgos@perlfect.com
# http://perlfect.com
# 
# 15 November 1998
# 
# requires the following perl modules:
# CGI, CGI::Carp, Data::Dumper
# 
# requires the following scripts
# indexer.pl >= v1.0
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#


use CGI;
use CGI::Carp qw(fatalsToBrowser);
use Data::Dumper;

my $version = "1.1";

#######################################################################
# User configurable variables start here

#Where the indexer should start...
my $base_dir="/home/nick/perlfect/www";

#The base url of you site
my $base_url="http://thekla.show.biz/";

#The flattened index file
my $flat_index_file='/home/nick/perlfect/www/cgi-bin/data/word.index';

#The file which describes the assignments of documents to numbers
my $file_index_file='/home/nick/perlfect/www/cgi-bin/data/file.index';

# You shouldn't have to change anything below this line
#######################################################################

require $flat_index_file;
require $file_index_file;

my %freq=%{$rfreq};
my %file_index=%{$rfile_index};

my $query;

my $query_string;
my @keywords;

my %results;
my $buffer;

my $html_out=<<'EOHTML';
qq{
<HTML>
  <HEAD>
    <TITLE>Search Results</TITLE>
  </HEAD>  
  <BODY bgcolor="#ffffff" text="#000000" link="#006699" vlink="#004679">
      <TABLE align="center" border="0" width="620" bgcolor="#000000" cellpadding="2" cellspacing="0">
      <TR><TD>
		<TABLE border="0" width="100%" bgcolor="#ffffff" cellpadding="10" cellspacing="0">
        <TR><TD align="center" bgcolor="#006699"><font size="+2" color="#ffffff"><b>Search Results</b></font></TD></TR>
		  <TR><TD>$buffer</TD></TR>
        <TR><TD align="right" bgcolor="#c0c0c0">
            <font size="-1">Perlfect Search v$version - (c)1998 <a href="http://perlfect.com">Perlfect Solutions</a></font>
        </TD></TR>
		</TABLE>
      </TD></TR>
      </TABLE>
  </BODY>
</HTML>
}
EOHTML

$query=new CGI;
$query_string=normalize($query->param('query'));
@keywords=split " ",$query_string;

print "The keywords are: @keywords\n";

&locate_documents;
&sort_documents;

print $query->header;
print eval $html_out;

sub locate_documents {
  my $keyword;
  my $f_index;

  foreach $keyword (@keywords) {
    foreach $f_index (keys %{$freq{$keyword}}) {
      $results{$f_index}+=$freq{$keyword}{$f_index};
    }
  }
}

sub sort_documents {
  my $f_index;
  my $url;
  my @scores;
  my $score;
  my $max_score;
  my $rel_score;
  my $documents;
  my $title;
  my $description;

  @scores=values %results;
  while ($score=shift @scores) {
      $max_score=$score if $score>$max_score;
  }
		       
  @documents=keys %results;
  
  $buffer.="<H3>Your search for: <FONT color=\"#006699\"><B>".$query->param('query')."</B></FONT> resulted in ".($#documents+1)." matches:<BR><BR></H3>\n";
  
  $buffer.="<OL>\n";
  foreach $f_index (sort {$results{$a}<=$results{$b}} keys %results) {
    $url=$base_url.$file_index{$f_index}{file};
    if ($max_score) {
      $rel_score=$results{$f_index}/$max_score*100;
      $rel_score=~s/(\d+)\.\d+/$1/;
    }

    if ($file_index{$f_index}{title}) {
      $title=$file_index{$f_index}{title};
      $title=~s/Perlfect Solutions\s*-\s*(.*)/$1/i;
    } else {
      $title="Untitled";
    }
    
    if ($file_index{$f_index}{description}) {
      $description=$file_index{$f_index}{description};
    } else {
      $description="";
    }

    $buffer.="\t<LI><A href=\"$url\">$title</A>&nbsp;&nbsp;<BR><FONT size=\"-1\">$description</FONT><BR><FONT size=\"-1\" color=\"000000\"><B>Score:</B> $rel_score% </FONT><BR><FONT size=\"-1\"><B> URL: </B><FONT color=\"#808080\">$url</FONT></FONT></LI><BR><BR>\n";
  }

  $buffer.="</OL>\n";
}

sub normalize {
  my $word=$_[0];

  $word=~s/\n/ /g;
  $word=~s/\W/ /g;
  $word=~s/\d+/ /g;
  $word=~s/\b\w\b//g;
  $word=~s/\s+/ /g;
   
  return lc $word;
}
